// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "assert/assert.hpp"

namespace Dawn {
  enum TicTacToeTileState {
    TIC_TAC_TOE_EMPTY,
    TIC_TAC_TOE_NOUGHT,
    TIC_TAC_TOE_CROSS
  };

  enum TicTacToeTileState ticTacToeDetermineWinner(
    const std::map<uint8_t, enum TicTacToeTileState> board,
    std::vector<uint8_t> *winningCombo
  );

  int32_t ticTacToeGetAiMove(
    std::map<uint8_t, enum TicTacToeTileState> board,
    enum TicTacToeTileState player
  );
}